/**
   Print a table of typical relative problem size
   increases for problems with various complexities.
 
   @author Jim Teresco, terescoj@cs.williams.edu, jteresco@siena.edu,
   terescoj@strose.edu
*/

public class ProblemSizes {

    public static void main(String[] args) {
	java.text.DecimalFormat dfm = new java.text.DecimalFormat("##.###");
	java.util.Scanner r = new java.util.Scanner(System.in);

	System.out.println("If a problem of size k takes a given amount of time, how large a problem can be");
	System.out.println("solved in some multiple of that time (or on a computer that many times faster?");
	while (true) {
	    System.out.println("Enter the multiplier of the computing time:");
	    long multiplier = r.nextLong();
	    if (multiplier == 0) break;
	    
	    System.out.println("O(log n)\tk^{"+multiplier+"}");
	    System.out.println("O(n)\t\t"+multiplier+"k");
	    System.out.println("O(n log n)\t<"+multiplier+"k");
	    System.out.println("O(n^2)\t\t"+dfm.format(Math.sqrt(multiplier))+"k");
	    System.out.println("O(n^3)\t\t"+dfm.format(Math.pow(multiplier,1.0/3.0))+"k");
	    System.out.println("O(2^n)\t\t~k+"+dfm.format(Math.log(multiplier)/Math.log(2)));
	}
    }
}
